fig64 <- function(post=F)
{
if(post)
  {#ps.options (colors=ps.colors.rgb[c("blue", "magenta", "cyan",
   #"green", "MediumBlue", "red", "black", "yellow", "blue"),])
    postscript("Fig64.ps", width=4.4, height=5, horizontal=F, pointsize=8)
  }
 else {if(dev.cur()==1) motif(); par(ask=T)}

 par(mfrow = c(2, 1),mar=c(5,3,3,1)+0.1)
 par(mex=0.5,csi=0.11)

 tbill12 <- matrix(scan("../datasets/tbill12m.dat", skip=26),ncol=2,byrow=T)
 tbill12 <- as.numeric(tbill12[,2])
 n <- length(tbill12)
 y <- (tbill12[2:n]-tbill12[1:(n-1)])^2
 x <- tbill12[1:(n-1)]

 #write(t(cbind(x,y)),".fig64a.dat", ncol=2)       ## record the data
 #write(t(cbind(x,diff(tbill12))),".fig64b.dat", ncol=2)  ## record the data
 out1 <- matrix(scan(".fig64a.out", skip=3),ncol=4,byrow=T)
                                           ## output of local linear fit

 plot(x,y,ylim=c(0,0.6),xlab="(a)", type="n")

 h <- 3.06 
 #polygon(c(5-h, 5+h, 5+h, 5-h, 5-h), c(0.5, 0.5, 0, 0, 0.5), col=4)
 polygon(c(12-h, 12+h, 12+h, 12-h, 12-h), c(.6, .6, .00,.00, .6), col=4)

######### local least square at point x=5
#   w <- 1 - (x-5)^2/h^2       ;                 #Epanechnikov kernel
#   x1 <- x[ w > 0]
#   y1 <- y[w > 0]
#   w1 <- w[w > 0]
#   coef <- lsfit(x1,y1,w1)$coef
#   lines(x1,coef[1]+coef[2]*x1,lty=1,lwd=2)
#   lines(x1[order(x1)],0.2*w1[order(x1)],lty=3,lwd=2)
#   lines(c(5,5),c(0, 120), lty=2)

######### local least square at point x=12
   w <- 1 - (x-12)^2/h^2       ;                 #Epanechnikov kernel
   x1 <- x[ w > 0]
   y1 <- y[w > 0]
   w1 <- w[w > 0]
   coef <- lsfit(x1,y1,w1)$coef
   lines(x1,coef[1]+coef[2]*x1,lty=4,lwd=1)
   lines(x1[order(x1)],0.1*w1[order(x1)],lty=2,lwd=1)
   lines(c(12,12),c(0, .5), lty=2)


 points(x,y) 
 lines(out1[,1], out1[,2], lwd=3)
 title("Conditional Second moment for 12-month Tbill")

############# Plot volatility function ########################
 out2 <- matrix(scan(".fig64b.out", skip=7, n=505), ncol=5, nrow=101, byrow=T)
 plot(out1[,1], sqrt(out1[,2]), type="l", xlab="(b)", lwd=1)
 lines(out2[,1],sqrt(out2[,4]),lty=2)
 coef <- lsfit(log(out1[1:95,1]), log(out1[1:95,2])/2)$coef
 #const <- mean(log(rchisq(100000,1))/2)    = -0.6317928
 #coef <- lsfit(log(x), log(y)/2)$coef
 lines(out1[,1], exp(coef[1]+coef[2]*log(out1[,1])),lty=3)
 title("Volatility function for 12-month Treasury Bill")
 coef
}
